import { DependencyList, EffectCallback } from 'react';
import { CallOptions } from 'nice-grpc-common';

export declare const useIsMounted: () => boolean;
export declare const useIsMobile: () => boolean;
export declare const useSynchronizingState: <V>(value: V) => readonly [V, import('react').Dispatch<import('react').SetStateAction<V>>];
export declare const useReload: () => [number, () => Promise<void>];
export declare const useEffectOnce: (effect: EffectCallback) => void;
export declare const usePromiseOnce: <T>(p: () => Promise<T | void>) => void | T | null;
export declare const usePromise: <T>(p: () => Promise<T | void>, deps?: DependencyList) => void | T | null;
export declare const useQuery: <T>(q: () => Promise<T | void | undefined> | undefined, deps?: DependencyList) => T | null | undefined;
export declare const useQueryOnce: <T>(q: () => Promise<T | undefined> | undefined) => T | null | undefined;
export declare const useAsync: (effect: () => Promise<void> | undefined, deps?: DependencyList) => void;
export declare const useAsyncOnce: (effect: () => Promise<void> | undefined) => void;
export declare const useAsyncReturn: <T>(effect: () => Promise<T | void>, deps?: DependencyList) => readonly [void | T | null, import('react').Dispatch<import('react').SetStateAction<void | T | null>>];
export declare const useAsyncReturnOnce: <T>(effect: () => Promise<T | void>) => readonly [void | T | null, import('react').Dispatch<import('react').SetStateAction<void | T | null>>];
export declare const useCallbackOnce: <T extends (...args: any[]) => any>(callback: T) => T;
export declare const useAsyncIterableOnce: <T>(fn: (opts: CallOptions) => AsyncIterable<T>, key?: keyof T) => any;
export declare const useCollectedAsyncIterableOnce: <T>(fn: (opts: CallOptions) => AsyncIterable<T>, key?: keyof T) => any[];
export declare const useChanged: <T>(data: T, timeout?: number) => [boolean, (b: boolean) => void];
export declare const usePersistedState: <T>(defaultValue: T, key: string) => [T, (state: T) => void];
export interface Confirm {
    withConfirm: (msg: string, action: () => Promise<void>) => () => Promise<void>;
    waiting: boolean;
    confirm: () => Promise<void>;
    cancel: () => void;
    msg: string;
}
export declare const useConfirm: () => Confirm;
export declare const watch: <T>(fn: (opts: CallOptions) => AsyncIterable<T>, callback: (res: T) => void, signal: AbortSignal) => Promise<void>;
